urlbase="/meteo/cgi?"
archive_base="/meteo/archive";

var params = window.location.pathname.split('/').slice(-4);
var sensor_id = params[1];
var sensor = params[2];
var param = params[3];

var sensor_path = sensor_id + "." + sensor + "." + param;

var properties;

function processDataset(dataset,sensorid,sensorname,paramname) {
  var scale = properties["scale"][sensorid+"."+sensorname+"."+paramname]
  if (scale) {
    var result=[];
    for (idx in dataset) {
      newRec = {};
      newRec.t = dataset[idx].t
      newRec.y = dataset[idx].y * scale[0];
      result.push(newRec);
    }  
    return result;
  } else { 
    return dataset;
  }
}

function drawGraph(graphData) {

  document.getElementById("archive").href = archive_base+"////"+sensor_id + "/" + sensor + "/" + param;

  var div = document.getElementById("chartdiv");
  var canvas = document.getElementById("chart");
  
  canvas.width = div.style.width;
  canvas.height = div.style.height;

  var ctx = canvas.getContext('2d');
  var color = Chart.helpers.color;

  if (param=="*") {

    var cfg = {
      type: 'bar',
      data: {
        datasets: [
        ]      
      },
      options: {
        animation: {
          duration: 0,
        },
        hover: {
          animationDuration: 0,
        },
        responsiveAnimationDuration: 0,
        legend: {
          labels: {
            fontColor: properties["fonts"]["legend"]["color"],
            fontSize: properties["fonts"]["legend"]["size"],
            fontStyle: properties["fonts"]["legend"]["style"],
          }
        },
        scales: {
          xAxes: [{
            type: 'time',
            distribution: 'series',
            scaleLabel: {
              fontColor: properties["fonts"]["axes"]["color"],
              fontSize: properties["fonts"]["axes"]["size"],
              fontStyle: properties["fonts"]["axes"]["style"],
            }
          }],
          yAxes: [{
            scaleLabel: {
              display: true,
              fontColor: properties["fonts"]["axes"]["color"],
              fontSize: properties["fonts"]["axes"]["size"],
              fontStyle: properties["fonts"]["axes"]["style"],
            }
          }]
        }  
      }
    }

    for (paramname in graphData) {

      cfg.data.datasets.push(
        {
          label: properties["names"][sensor_id+"."+sensor+"."+paramname],
          data: processDataset(graphData[paramname],sensor_id,sensor,paramname),
          borderColor: properties["colors"][sensor_id+"."+sensor+"."+paramname],
          type: 'line',
          fill: false,
          pointRadius: 0,
          borderWidth: 2
        }
      )
    
    }
  
  } else {

    var y_label = properties["names"][sensor_path];
    if (properties["units"][sensor_path]) {
      y_label = y_label + ", " + properties["units"][sensor_path];
    }

    var cfg = {
      type: 'bar',
      data: {
        datasets: [
          {
            label: properties["names"][sensor_path],
            backgroundColor: color(properties["colors"][sensor_path]).alpha(0.5).rgbString(),
            borderColor: properties["colors"][sensor_path],
            data: processDataset(graphData,sensor_id,sensor,param),
            type: 'line',
            pointRadius: 0,
            fill: true,
            borderWidth: 2
          }
        ]      
      },
      options: {
        animation: {
          duration: 0,
        },
        hover: {
          animationDuration: 0,
        },
        responsiveAnimationDuration: 0,
        legend: {
          labels: {
            fontColor: properties["fonts"]["legend"]["color"],
            fontSize: properties["fonts"]["legend"]["size"],
            fontStyle: properties["fonts"]["legend"]["style"],
          }
        },
        scales: {
          xAxes: [{
            type: 'time',
            distribution: 'series',
            scaleLabel: {
              fontColor: properties["fonts"]["axes"]["color"],
              fontSize: properties["fonts"]["axes"]["size"],
              fontStyle: properties["fonts"]["axes"]["style"],
            }
          }],
          yAxes: [{
            scaleLabel: {
              display: true,
              labelString: y_label,
              fontColor: properties["fonts"]["axes"]["color"],
              fontSize: properties["fonts"]["axes"]["size"],
              fontStyle: properties["fonts"]["axes"]["style"],
            }
          }]
        }  
      }
    }

  }
  var chart = new Chart(ctx, cfg);
}

function RefreshGraph() {

  var req = new XMLHttpRequest();

  req.onreadystatechange = function () {
    if (this.readyState != 4) return; 
    if (this.status != 200) {
      setTimeout(RefreshGraph,30000);
      return;
    }
    var graphData = JSON.parse(this.responseText);
    drawGraph(graphData);
    setTimeout(RefreshGraph,30000)
  };
  
  req.open("GET", urlbase+"get/"+sensor_id+"/"+sensor+"/"+param, true);
  req.send();

}

function GetProperties() {
  var req = new XMLHttpRequest();

  req.onreadystatechange = function () {
    if (this.readyState != 4) return; 
    if (this.status != 200) {
      setTimeout(GetProperties,30000);
      return;
    }
    properties = JSON.parse(this.responseText);
    setTimeout(RefreshGraph,100)
  };
  
  req.open("GET", urlbase+"props", true);
  req.send();

}

setTimeout(GetProperties,100)
